package sdApi1

import (
	"bytes"
	"encoding/json"
	"fmt"
	"net/http"

	models "devel.mephi.ru/dyokunev/go-asu-models"
)

var (
	apiKey string
)

func SetApiKey(newApiKey string) {
	apiKey = newApiKey
}

func GetUnits() (units models.Units, err error) {
	err = getItems(&units, "https://sd.mephi.ru/api/1/units.json")
	if err != nil {
		return
	}

	units.CalculateTree()

	return
}

func GetPeople() (people models.People, err error) {
	err = getItems(&people, "https://sd.mephi.ru/api/1/faces.json")
	return
}

func getItems(items interface{}, url string) error {
	client := &http.Client{}

	req, _ := http.NewRequest("GET", url, nil)
	q := req.URL.Query()
	q.Add("api_key", apiKey)
	req.URL.RawQuery = q.Encode()
	response, err := client.Do(req)
	if err != nil {
		return err
	}
	defer response.Body.Close()

	var bytesArray []byte

	buf := bytes.NewBuffer(bytesArray)
	_, err = buf.ReadFrom(response.Body)
	if err != nil {
		return err
	}

	if err := json.Unmarshal(buf.Bytes(), &items); err != nil {
		return fmt.Errorf("Cannot parse: %v: \"%v\"", string(buf.Bytes()), err.Error())
	}

	return nil
}
